package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmQuarterlyWaterUsage;
import com.zksy.system.basicData.service.CrmQuarterlyWaterUsageService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 季度用水明细Controller
 *
 * @author sy
 * @date 2024-06-04
 */
@RestController
@RequestMapping("/crmQuarterlyWaterUsage")
@Api(tags = "季度用水明细", description = "季度用水明细desc")
public class CrmQuarterlyWaterUsageController extends BaseController{

    @Autowired
    private CrmQuarterlyWaterUsageService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "季度用水明细搜索getById")
    public CrmQuarterlyWaterUsage getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "季度用水明细分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "季度用水明细查询所有")
    public List<CrmQuarterlyWaterUsage> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增季度用水明细
     */
    @PostMapping("/save")
    @ApiOperation(value = "季度用水明细新增")
    @Log(title = "新增季度用水明细", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmQuarterlyWaterUsage crmQuarterlyWaterUsage) {
        return service.save(crmQuarterlyWaterUsage);
    }

    /**
     * 修改季度用水明细
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "季度用水明细修改")
    @Log(title = "修改季度用水明细", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmQuarterlyWaterUsage crmQuarterlyWaterUsage) {
        return service.updateById(crmQuarterlyWaterUsage);
    }

    /**
     * 导入季度用水明细
     */
    @ApiOperation("季度用水明细导入")
    @Log(title = "季度用水明细", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmQuarterlyWaterUsage> crmQuarterlyWaterUsageAll = service.list();
            List<CrmQuarterlyWaterUsage> list = ExcelUtils.readMultipartFile(file, CrmQuarterlyWaterUsage.class,CrmQuarterlyWaterUsage.class.getDeclaredFields().length - 2);
            if(crmQuarterlyWaterUsageAll != null && crmQuarterlyWaterUsageAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("季度用水明细导出")
    @Log(title = "季度用水明细", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmQuarterlyWaterUsage> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"季度用水明细",wrapperList,CrmQuarterlyWaterUsage.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "季度用水明细", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除季度用水明细", notes = "删除季度用水明细")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"季度用水明细模板");
    }
}

